var foxampPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

if (foxampPrefs.getPrefType("foxamp.update.value") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setIntPref("foxamp.update.value", 5);	
}



if (foxampPrefs.getPrefType("foxamp.scrolltitle.enable") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setBoolPref("foxamp.scrolltitle.enable", true);	
}



if (foxampPrefs.getPrefType("foxamp.scrolltitle.value") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setIntPref("foxamp.scrolltitle.value", 500);	
}



if (foxampPrefs.getPrefType("foxamp.winampautostart") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setBoolPref("foxamp.winampautostart", true);	
}



if (foxampPrefs.getPrefType("foxamp.winampdir") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setCharPref("foxamp.winampdir", "");	
}

var winampOldSongtitle;
var hwndWinamp;
var user32;

function launchWinamp()
{
	var foxampPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var foxampSettingWinampAutostart = foxampPrefs.getBoolPref("foxamp.winampautostart");

	if (foxampSettingWinampAutostart == true)
	{
		try
		{
			if (findWinamp(true) == false)
			{
				var foxampSettingWinampDir = foxampPrefs.getCharPref("foxamp.winampdir");

				var winampPath = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);
				winampPath.initWithPath(foxampSettingWinampDir + "\\winamp.exe");
				
				var winampProcess = Components.classes["@mozilla.org/process/util;1"].getService(Components.interfaces.nsIProcess);
		
				// Try to run Winamp
				winampProcess.init(winampPath);
				winampProcess.run(false, [], 0);
			}
		}
		catch (e) { }
	}
}

Components.utils.import("resource://gre/modules/ctypes.jsm");

function openUser32()
{
	user32 = ctypes.open('user32.dll');
}

function closeUser32()
{
	user32.close();
}

function findWinamp(open)
{
	if (open == true)
		openUser32();
	
 	var findWindowW = user32.declare('FindWindowW', ctypes.winapi_abi, ctypes.uintptr_t, ctypes.jschar.ptr, ctypes.jschar.ptr);
	
	hwndWinamp = findWindowW('Winamp v1.x', null);
	
	if (open == true)
		user32.close();
	
	return (hwndWinamp != 0);
}

function winampExecute(msg)
{
	launchWinamp();
	openUser32();
	
	if (findWinamp(false) == false)
	{
		closeUser32();
		return;
	}
	
 	var sendMessage = user32.declare('SendMessageW', ctypes.winapi_abi, ctypes.uintptr_t, ctypes.uintptr_t, ctypes.uint32_t, ctypes.uintptr_t, ctypes.uintptr_t);
	
	sendMessage(hwndWinamp, 0x0111 /* WM_COMMAND */, msg, 0);
	
	var lib = ctypes.open('kernel32.dll');
	var sleepFunc = lib.declare('Sleep', ctypes.winapi_abi, ctypes.void_t, ctypes.uint32_t);
	
	sleepFunc(0);
	lib.close();
	
	winampSaveSongticker();
	closeUser32();
}

var winampCurrentVolume = 255; /* from 0(min) to 255(max), start with max */

function winampChangeVolume(outputNewVolume)
{
	launchWinamp();
	openUser32();
	
	if (findWinamp(false) == false)
	{
		closeUser32();
		return;
	}
	
	if (outputNewVolume == "PLUS")
	{
		winampCurrentVolume = winampCurrentVolume + 5;
		
		if (winampCurrentVolume > 255)
			winampCurrentVolume = 255;
	}
	else if (outputNewVolume == "MINUS")
	{
		winampCurrentVolume = winampCurrentVolume - 5;

		if (winampCurrentVolume < 0)
			winampCurrentVolume = 0;
	}
	else
		winampCurrentVolume = outputNewVolume;

 	var sendMessage = user32.declare('SendMessageW', ctypes.winapi_abi, ctypes.uintptr_t, ctypes.uintptr_t, ctypes.uint32_t, ctypes.uintptr_t, ctypes.uintptr_t);
	
	sendMessage(hwndWinamp, 0x0400 /* WM_USER */, winampCurrentVolume, 122);
	closeUser32();
}

function winampShowHide()
{
	launchWinamp();
	openUser32();
	
	if (findWinamp(false) == false)
	{
		closeUser32();
		return;
	}

 	var isWindowVisible = user32.declare('IsWindowVisible', ctypes.winapi_abi, ctypes.int32_t, ctypes.uintptr_t);
 	var showWindow = user32.declare('ShowWindow', ctypes.winapi_abi, ctypes.int32_t, ctypes.uintptr_t, ctypes.int32_t);
	
	if (isWindowVisible(hwndWinamp) == 0)
		showWindow(hwndWinamp, 1); // SW_SHOWNORMAL
	else
	{
		showWindow(hwndWinamp, 6); // SW_MINIMIZE
		showWindow(hwndWinamp, 0); // SW_HIDE
	}
	
	closeUser32();
}

function winampSaveSongticker()
{
	var newSong;
	
	openUser32();
	
	if (!findWinamp(false))
		newSong = 'Winamp is not running';
	else
	{
		var getWindowText = user32.declare("GetWindowTextW", ctypes.winapi_abi, ctypes.int32_t, ctypes.uintptr_t, ctypes.jschar.ptr, ctypes.int32_t);
		var songNamePtr = ctypes.jschar.array()(250);
	
		var ret = getWindowText(hwndWinamp, songNamePtr, 250);
		
		if (ret == 0)
			newSong = 'Winamp is not running';
		else
		{
			windowTitle = songNamePtr.readString();
			
			var winampPos = windowTitle.lastIndexOf(' - Winamp');
			var dotPos = windowTitle.indexOf('. ');
			
			if (winampPos == -1)
				winampPos = windowTitle.length;

			if (dotPos == -1)
				dotPos = 0;
			else
				dotPos += 2;
			
			newSong = windowTitle.substring(dotPos, winampPos);
		}
	}

	if (winampOldSongtitle != newSong)
	{
		winampOldSongtitle = newSong;
		
		var winampUpdateSongTickerFld = document.getElementById("statusbar-winamp-songticker");
		
		if (newSong.length > 40)
			winampUpdateSongTickerFld.label = newSong + " - ";
		else
			winampUpdateSongTickerFld.label = newSong;
	}
	
	closeUser32();
	
	var foxampPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var foxampSettingUpdate = foxampPrefs.getIntPref("foxamp.update.value");
	
	foxampSettingUpdate = foxampSettingUpdate * 1000;
	
	setTimeout(winampSaveSongticker, foxampSettingUpdate); // Redo this function.
}

window.setTimeout(winampSaveSongticker, 1000);

function winampTickSongName()
{
	var foxampPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var foxampSettingSongtickerEnable = foxampPrefs.getBoolPref("foxamp.scrolltitle.enable");
		
	if (foxampSettingSongtickerEnable == true)
	{
		var winampSongTickerFld = document.getElementById("statusbar-winamp-songticker");

		var winampTempName;
		winampTempName = winampSongTickerFld.label;	
		
		if (winampTempName.length > 40)
		{
			winampTempName = winampTempName + winampTempName.substring(0, 1); //winampSongTickerFld.length
			winampTempName = winampTempName.substring(1);
			winampSongTickerFld.label = winampTempName;
		}
		
	}
		
	var foxampSettingSongtickerValue = foxampPrefs.getIntPref("foxamp.scrolltitle.value");
	setTimeout(winampTickSongName, foxampSettingSongtickerValue); // "Tick" the track name..
}

window.setTimeout(winampTickSongName, 1000);
